package cn.com.tenlion.buildingpictures.dao.picturestemplate;

import cn.com.tenlion.buildingpictures.pojo.dtos.picturestemplate.PicturesTemplateBuildingDTO;
import cn.com.tenlion.buildingpictures.pojo.dtos.picturestemplate.PicturesTemplateDTO;
import ink.wgink.exceptions.RemoveException;
import ink.wgink.exceptions.SaveException;
import ink.wgink.exceptions.SearchException;
import ink.wgink.exceptions.UpdateException;
import org.springframework.stereotype.Repository;
import java.util.List;
import java.util.Map;

/**
 * @ClassName: IPicturesTemplateDao
 * @Description: 大数据展示的模板管理
 * @Author: WenG
 * @Date: 2020-10-20 10:49
 * @Version: 1.0
 **/
@Repository
public interface IPicturesTemplateDao {

    /**
     * 新增大数据展示的模板管理
     *
     * @param params
     * @throws SaveException
     */
    void savePicturesTemplate(Map<String, Object> params) throws SaveException;

    /**
     * 删除大数据展示的模板管理
     *
     * @param params
     * @throws RemoveException
     */
    void removePicturesTemplate(Map<String, Object> params) throws RemoveException;

    /**
    * 删除大数据展示的模板管理（物理）
    *
    * @param params
    * @throws RemoveException
    */
    void deletePicturesTemplate(Map<String, Object> params) throws RemoveException;

    /**
     * 修改大数据展示的模板管理
     *
     * @param params
     * @throws UpdateException
     */
    void updatePicturesTemplate(Map<String, Object> params) throws UpdateException;

    /**
     * 大数据展示的模板管理详情
     *
     * @param params
     * @return
     * @throws SearchException
     */
    PicturesTemplateDTO getPicturesTemplate(Map<String, Object> params) throws SearchException;

    /**
     * 大数据展示的模板管理列表
     *
     * @param params
     * @return
     * @throws SearchException
     */
    List<PicturesTemplateDTO> listPicturesTemplate(Map<String, Object> params) throws SearchException;

    /**
    * 大数据展示的模板管理统计
    *
    * @param params
    * @return
    * @throws SearchException
    */
    Integer countPicturesTemplate(Map<String, Object> params) throws SearchException;

    PicturesTemplateDTO getPicturesTemplateByCode(String picturesTemplateCode) throws SearchException;

    void updataPicturesTemplateUrl(Map<String, Object> updateParams) throws UpdateException;

    void updatePicturesTemplatePublishStatus(Map<String, Object> params) throws UpdateException;

    List<Map<String, Object>> querySqlAll(String sql) throws SearchException;

    void updatePicturesTemplateContent(Map<String, Object> params) throws UpdateException;

    void updatePicturesTemplatePicture(Map<String, Object> map) throws UpdateException;

    void updatePictureTemplateStatus(Map<String, Object> params) throws UpdateException;

    List<PicturesTemplateBuildingDTO> list(Map<String, Object> queryParams) throws SearchException;

    PicturesTemplateBuildingDTO get(Map<String, Object> queryParams) throws SearchException;
}